<?php
$taxonomy_switch = $instance['news_taxonomy_selector'];
$post_category = $instance['taxonomy_category'];
$event_category = $instance['taxonomy_event_category'];
$news_post = $instance['news_post'];
$numberPosts = (!empty($instance['number_of_posts'])) ? $instance['number_of_posts'] : 4;
$link_text = wp_kses_post($instance['link_text']);
$link_url = wp_kses_post($instance['link_url']);
$link_text = ($link_text == '') ? esc_attr__('News and updates', 'solicitor') : $link_text;
$data_style = wp_kses_post($instance['listing_layout']['data_style']);
$slider_speed = wp_kses_post($instance['listing_layout']['slider_speed']);
if (is_array($taxonomy_switch)) {
	if (in_array('taxonomy', $taxonomy_switch)) {
	  $news_post = [];
	  if ($post_category) {
		$post_args = array('post_type' => 'post', 'posts_per_page' => '-1', 'tax_query' => array(array('taxonomy' => 'category', 'field' => 'slug', 'terms' => $post_category)));
		$post_list = new WP_Query($post_args);
		if ($post_list->have_posts()) : while ($post_list->have_posts()) : $post_list->the_post();
			$news_post[] = get_the_ID();
		  endwhile;
		endif;
		wp_reset_postdata();
	  }
	  if ($event_category) {
		$event_args = array('post_type' => 'event', 'posts_per_page' => '-1', 'tax_query' => array(array('taxonomy' => 'event-category', 'field' => 'slug', 'terms' => $event_category)));
		$event_list = new WP_Query($event_args);
		if ($event_list->have_posts()) : while ($event_list->have_posts()) : $event_list->the_post();
			$news_post[] = get_the_ID();
		  endwhile;
		endif;
		wp_reset_postdata();
	  }
	}
}
?>
<?php if ($news_post != '') { ?>
  <div class="notice-bar">
    <div class="container">
      <div class="row">
        <div class="col-md-8 col-sm-12 equalize">
          <div class="galleryflex flexslider" data-autoplay="yes" data-arrows="no" data-speed="<?php echo esc_attr($slider_speed); ?>" data-style="<?php echo esc_attr($data_style); ?>" data-direction="vertical">
            <ul class="slides">
              <?php $start = 1;
                foreach ($news_post as $id) { ?>
                <li class="slide">
                  <span class="icon-block"><i class="fa fa-newspaper-o"></i></span>
                  <p><a href="<?php echo esc_url(get_permalink($id)); ?>"><?php echo esc_attr(get_the_title($id)); ?></a></p>
                  <span class="meta-data">
					  <?php 
							$event_date = get_post_meta($id, 'solicitor_event_start_dt', true);
							if(!$event_date){
								echo esc_attr(get_the_date(get_option('date_format'), $id));
							} else {
								echo esc_attr(date_i18n(get_option('date_format'), strtotime($event_date)));
							}
						?>
					</span>
                </li>
              <?php
                  $start++;
                  if ($start > $numberPosts) {
                    break;
                  }
                } ?>
            </ul>
          </div>

        </div>
        <?php if ($link_url != '') { ?>
          <div class="col-md-4 col-sm-4 hidden-sm hidden-xs equalize">
            <a href="<?php echo sow_esc_url($instance['link_url']); ?>" <?php if ($instance['link_new_window']) echo 'target="_blank"' ?> class="btn btn-primary btn-block equalize"><span><?php echo esc_attr($link_text); ?></span><em><?php esc_html_e('See all', 'solicitor'); ?></em></a>
          </div>
        <?php } ?>
      </div>
    </div>
  </div>
<?php } ?>